#include <stdio.h>
// #include <malloc.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include<X11/keysym.h>
#define N 30
#define couleur 99

/*
Projet Info Graphique (Julien & Didier)

28-03-04  -  19/04/04

gcc -o RemplissageBalayage RemplissageBalayage.c -L/usr/X11R6/lib -lX11

gcc RemplissageBalayage.c -g -o RemplissageBalayage -L/usr/X11R6/lib -lX11

*/

/*************************** type *************************************/

// type porr lca
typedef struct Cote_Type {
  float Xmin;
  int Ymax;
  float UnSurM; // 1/m
  struct Cote_Type * Suivant;
} Cote_Type;

typedef struct Cote_Type * Cote;

// type pour SI
typedef struct SI_Type {
  int Ymin;
  Cote c;
  struct SI_Type * Suivant;
} SI_Type;

typedef struct SI_Type * SI;

// type pour point
typedef struct point {int x; int y;} point;

/*********************** var globale *************************/
// var pour SI/LCA
Cote lca;
SI s;
int dim=0;
point poly[N];

// var pour Graphique
GC gc;
Display *display;
int screen,N2;
Window win,root;
int win_larg,win_haut;
Colormap cmap;

// couleur
GC red_gc,green_gc,blue_gc;
XColor red_col,green_col,blue_col;
char red[] = "#FF0000", green[] = "#00FF00", blue[] = "#0000FF";

unsigned long white_pixel, black_pixel;

void Croix(int x0, int y0);
Cote creer_cote(Cote c);
SI creer_SI(SI s);
Cote nouveauCote(Cote c, float x,int y,float unsurm);
SI DepilerSI(SI s);
Cote DepilerCote(Cote c);
Cote supprimer(Cote c,int y);
SI nouveauSI(SI s, int x,int y,float m,int ymin);
/* void affichage(Cote c);
void affichage2(SI s); */
void transfert(int y);
void remplirSI();
void remplissageBalayage();
void TraceLigne(Cote lca, int y);


/*********************** Fonctions Graphiques **********************/

void contact_serveur(){
	if ((display = XOpenDisplay("")) == NULL) {
		fprintf(stderr, "Can't open Display\n");
		exit(1);
	}
} /* contact_serveur */

/* ******************************************************************** */

void Creat_fenetre(void) {
short border_width;

screen = DefaultScreen(display);
root = RootWindow(display,screen);

white_pixel= WhitePixel(display,screen);
black_pixel= BlackPixel(display,screen);

cmap = DefaultColormap(display,screen);

border_width = 3;

win_larg = DisplayWidth(display,screen)/4;
win_haut = DisplayHeight(display,screen)/4;

win = XCreateSimpleWindow(display,root,0,0,win_larg,win_haut,
	border_width,black_pixel,white_pixel);
gc=DefaultGC(display,screen);

XStoreName(display,win,"Remplissage Balayage");

XSetWindowColormap(display, win, cmap) ;

// SetForeground(display, gc, black_pixel);

XMapWindow(display,win);

}

/* ******************************************************************** */

void gerer_evenement() {
char *str3="Julien GONY & Didier STRAUS";
int i,dist,level,x0,y0;
long int p1,p2,p3;

int res;
int w, h;
int x, y, idx;

level=0;
XSelectInput(display,win,ExposureMask | KeyPressMask | ButtonPressMask);

for(;;) {
	KeySym keysym;
	XEvent ev;
	XNextEvent(display,&ev);

	switch(ev.type) {
		case Expose :

			break;

		case KeyPress :
			keysym = XLookupKeysym(&ev.xkey, 0);
  
    		if ((keysym >= XK_Left) && (keysym <= XK_Down)) { // appuyer sur une fleche pour quitter
				XClearWindow(display,win);
				XDrawString(display,win,gc,win_larg/5,win_haut/2,str3,strlen(str3));
				XFlush(display);
				sleep(3);
				XDestroyWindow(display,win);
				XCloseDisplay(display);
				exit(0);
			}
			else { // appuyer sur n'importe quelle touche pour arreter la saisie du polygone et le dessiner
				/* on affiche le polygone qu'on a defini */
				red_gc = XCreateGC(display, win, 0, 0);
             	XParseColor(display, cmap, red, &red_col);
             	XAllocColor(display, cmap, &red_col);
             	XSetForeground(display, red_gc, red_col.pixel);
			 	lca=creer_cote(lca);
			 	s=creer_SI(s);
			 	remplirSI();
			 
			 	for(i=0;i<dim-1;i++) {
			  		XDrawLine(display,win,red_gc,poly[i].x,poly[i].y,poly[i+1].x,poly[i+1].y);
			 	}
			 	XDrawLine(display,win,red_gc,poly[dim-1].x,poly[dim-1].y,poly[0].x,poly[0].y);
				
				remplissageBalayage();
			}
			break;
		
		case ButtonPress : // le bouton de la souris a ete presse
			/* on recupere les coordonnees de la position de la souris (x,y) */
			x0=ev.xbutton.x;
			y0=ev.xbutton.y;
			
			Croix(x0, y0); // on affiche une petite croix a la position du point
			
			poly[dim].x = x0;
			poly[dim].y = y0;
			dim++;
			break;
		
		default :
			fprintf(stderr,"J'ai recu un evt : %d\n",ev.type);
			break;
	} /* switch */
} /* for */

} /* gerer_evts */


/**************************** Fonctions utiles ********************************/

/************************ Creation ********************************/
/* Cree un cote */
Cote creer_cote(Cote c) {
  return(NULL);
}

/* Cree un SI */
SI creer_SI(SI s) {
  return(NULL);
}

/******************************** Ajout dans liste **************/

/* Ajout d'un nouveau cote trie selon Xmin puis unsurm */
Cote nouveauCote(Cote c, float x,int y,float unsurm) {
  Cote cTemp; // Temporaire (c'est le maillon qui va etre ajoute)
  Cote cMove; // Permet de ce deplacer dans la liste
  Cote cPrev; // Tout ce qui etait avant(de c a cMove)

  cTemp=malloc(sizeof(Cote_Type));
  cTemp->Xmin=x;
  cTemp->Ymax=y;
  cTemp->UnSurM=unsurm;
  cTemp->Suivant=NULL;

  cPrev = NULL;
  cMove = c;  
  while ((cMove != NULL) && (x > cMove->Xmin)) { // boucle de deplacement
    cPrev = cMove;
    cMove = cMove->Suivant;
  }
    
  if ((cMove == NULL) && (cPrev == NULL)) { // la liste est vide
      cTemp->Suivant = c;
      c = cTemp;
      return(c);
  }
  if ((cMove !=NULL) && (cMove->Xmin==x)) { // si x=Xmin, on trie selon UnSurM
      while((cMove != NULL) && (unsurm > cMove->UnSurM) && (cMove->Xmin==x)) {
        cPrev = cMove;
        cMove = cMove->Suivant;
      }  
  }       
  if (cPrev == NULL) { // si c'est le 1er element
      cTemp->Suivant = c;
      c = cTemp;
      return(c);
  }        
  // sinon le placer a cet endroit
  cPrev->Suivant = cTemp;
  cTemp->Suivant = cMove;
  return(c);
}

/***********************************************************/

//ajout ds SI trie selon ymin
SI nouveauSI(SI s, int x,int y,float m,int ymin) {
  SI sTemp; // Temporaire (c'est le maillon qui va etre ajoute)
  SI sMove; // Permet de ce deplacer dans la liste
  SI sPrev;
  Cote cNull;

  sTemp=malloc(sizeof(SI_Type));
  sTemp->Suivant=NULL;

  sPrev = NULL;
  sMove = s;
  while ((sMove != NULL)&&(sMove->Ymin < ymin)) { // boucle de deplacement
    sPrev = sMove;
    sMove = sMove->Suivant;
  }

    if ((sPrev == NULL) && (sMove == NULL)) { // si c'est le 1er element
        sTemp->Ymin=ymin;
        cNull = creer_cote(cNull);
        sTemp->c=nouveauCote(cNull,x,y,m);
        sTemp->Suivant = s;
        s = sTemp;
        // printf("NULL %d \n",ymin);
        return(s);
    }
    else {
      if (sMove == NULL) { // si c'est le dernier maillon
        sTemp->Ymin=ymin;
        sTemp->Suivant=NULL;
        cNull = creer_cote(cNull);
        sTemp->c=nouveauCote(cNull,x,y,m);
        sPrev->Suivant = sTemp;
        // printf("dernier %d \n",ymin);
        return(s);
      }
      if (sMove->Ymin == ymin) { // sinon le placer dans ce maillon
        sMove->c=nouveauCote(sMove->c,x,y,m);
        // printf("pas NULL et=ymin %d \n",ymin);
        return(s);
      }
		// si c'est un maillon qui n'existe pas encore
      sTemp->Ymin=ymin;
      cNull = creer_cote(cNull);
      sTemp->c=nouveauCote(cNull,x,y,m);
      sPrev->Suivant = sTemp;
      sTemp->Suivant = sMove;
      // printf("pas NULL et<>ymin %d \n",ymin);
      return(s);
    }
}

/********************************* Suppression *************************************/

/* suppression du premier element de SI */
SI DepilerSI(SI s) {
  SI sMove;

  sMove=s;
  s=sMove->Suivant;
  return(s);
}

/****************************************************/

/* suppression du premier element de lca */
Cote DepilerCote(Cote c) {
  Cote cMove;

  cMove=c;
  c=cMove->Suivant;
  return(c);
}
/***********************************************************/

/* Suppression d'un element ayant un y donne de la liste */
Cote supprimer(Cote c,int y) {
  Cote cTemp;
  Cote cMove;
  Cote cPrev;
  int trouve=1;

  while(trouve){ // tant qu'on en supprime, on recommence
        cPrev = NULL;
        cMove = c;
        while (cMove != NULL && cMove->Ymax != y) { // on se deplace
           cPrev = cMove;
           cMove = cMove->Suivant;
        }
        if ((cPrev == NULL) && (cMove == NULL)) { // 1 seul maillon
           return(NULL);
        }
        if (cPrev == NULL) { // 1er maillon
           c=DepilerCote(c);
        }
        else {
          if (cMove != NULL) { // si on trouve
            cTemp = cMove;
            cPrev->Suivant = cMove->Suivant;
            free(cTemp);
          }
          else { // si on a rien trouve
            trouve=0;
          }
        }
  }
  return(c);
}

/********************* affichage pour tester les liste *******************/
/*
// affichage lca
void affichage(Cote c) {
  Cote cMove;
  cMove=c;
  while(cMove != NULL ) {
      printf("%f,%d,%f -> ",cMove->Xmin,cMove->Ymax,cMove->UnSurM);
      cMove = cMove->Suivant;
  }
  printf(" NULL \n");
}

// affichage2 SI
void affichage2(SI s) {
  SI sMove;
  sMove=s;
  while(sMove != NULL ) {
      printf("%d :",sMove->Ymin);
      affichage(sMove->c);
      sMove = sMove->Suivant;
  }
  printf(" NULL \n");
}
*/

/***************************** Fonctions de remplissage *******************************/

/*ajout des cotes de Si dans LCA pour un y donne et suppression du maillon de SI*/
void transfert(int y) {
  if (s->Ymin==y) { // ymin = y courrant
    while(s->c!=NULL) { // on place tous les cotes dans LCA, et on supprime l'entree de SI
        lca=nouveauCote(lca,s->c->Xmin,s->c->Ymax,s->c->UnSurM);
        s->c=DepilerCote(s->c);
    }
    s=DepilerSI(s);
    /* affichage(lca);
    affichage2(s); */
  }
}

/*************************************************************/

/*Initialisation de SI qui contient tout les cots*/
void remplirSI(){
  int i;
  int xmin,ymax,ymin;
  float UnSurEm;
  float dx,dy;
  
  // boucle pour remplir SI
  for(i=0;i<dim-1;i++) {
    if (poly[i].y != poly[i+1].y) { // on ne met pas les lignes horizontales
        if (poly[i].y<poly[i+1].y) { // on cherche le min et le max
           xmin=poly[i].x;
           ymax=poly[i+1].y;
           ymin=poly[i].y;
        }
        else { xmin=poly[i+1].x;
           ymax=poly[i].y;
           ymin=poly[i+1].y;
        }
		  dx=poly[i].x-poly[i+1].x;
		  dy=poly[i].y-poly[i+1].y;
        UnSurEm=dx/dy; // calcul de 1/m
        s=nouveauSI(s,xmin,ymax,UnSurEm,ymin); // insertion du cote dans SI
        }
    }
  // traite le dernier cote: du sommet "dim-1" au sommet 0
  if (poly[dim-1].y!=poly[0].y) { // on ne met pas les lignes horizontales
    if (poly[dim-1].y<poly[0].y) { // on cherche le min et le max
        xmin=poly[dim-1].x;
        ymax=poly[0].y;
        ymin=poly[dim-1].y;
    }
    else { xmin=poly[0].x;
        ymax=poly[dim-1].y;
        ymin=poly[0].y;
    }
	dx=poly[dim-1].x-poly[0].x;
	dy=poly[dim-1].y-poly[0].y;
    UnSurEm=dx/dy;
    s=nouveauSI(s,xmin,ymax,UnSurEm,ymin);
  }
}

/********************************************************************/

// remplissageBalayage
void remplissageBalayage() {
  int i=s->Ymin; // point le plus bas du polygone
  
  while((s!=NULL) || (lca!=NULL)) {
      if (lca!=NULL) {
          lca=supprimer(lca,i); // on supprime si Ymax= y courant
          // printf("Suppression LCA: %d  ",i);
      }
      if (s!=NULL) {
          transfert(i); // on transfert de SI a LCA si ymin= y courant
      }
          /* printf("SI: %d  ",i);
          affichage2(s);
          printf("LCA: %d  ",i);
          affichage(lca); */
      TraceLigne(lca, i+1); // on trace la ligne
      i++;
  }
} /* remplissageBalayage */

/********************************************************************/

// TraceLigne
void TraceLigne(Cote lca, int y) {
  float xa,xb;
  int p=0;
  Cote cMove;
  green_gc = XCreateGC(display, win, 0, 0);
  XParseColor(display, cmap, green, &green_col);
  XAllocColor(display, cmap, &green_col);
  XSetForeground(display, green_gc, green_col.pixel);
  
  cMove=lca;
  while(cMove != NULL ) {
      if(p==0){ // sert pour ne tracer que par pair.
       xa=cMove->Xmin+cMove->UnSurM;//point le plus  droite
		cMove->Xmin=xa;
       cMove = cMove->Suivant;
       xb=cMove->Xmin+cMove->UnSurM;//poin  gauche
		cMove->Xmin=xb;
       XDrawLine(display, win, green_gc,xa,y,xb,y);
       p=1;
      }
      else {
        cMove = cMove->Suivant;
        p=0;//si c'est impair
      }
  }
} /* TraceLigne */

/* *********************************************************** */

void Croix(int x0,int y0) {
	XDrawPoint(display,win,gc,x0,y0);
	XDrawPoint(display,win,gc,x0+1,y0);
	XDrawPoint(display,win,gc,x0-1,y0);
	XDrawPoint(display,win,gc,x0,y0-1);
	XDrawPoint(display,win,gc,x0,y0+1);
} /* Croix */

/******************* MAIN ******************************/
int main () {
	int i;
	
	for(i=0;i<N;i++) {
		poly[i].x=0;
		poly[i].y=0;
	}

	contact_serveur();
	Creat_fenetre();
	gerer_evenement();

	return 0;
}
