#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/keysym.h> // pour la gestion des touches (fleches, barre espace,...)

#define NMAX 200   // taille maximum de la pile
#define N 30       // nombre de sommet du polygone
#define couleur 99 // 'couleur' pour la structure image

/*
Projet Info Graphique
Par Didier STRAUS & Julien GONY
http://www.Software-DS.com

gcc -o RemplissageLigne RemplissageLigne.c -L/usr/X11R6/lib -lX11

gcc RemplissageLigne.c -g -o RemplissageLigne -L/usr/X11R6/lib -lX11

commence le 14-03-04 termine le 07/04/04  derniere modif le 16/04/04
*/

// Point
typedef struct {
 int x;
 int y;
} coord;

// Pile
typedef struct pile {
 coord val[NMAX];
 int hauteur;
} pile;

// variables
GC gc;
Display *display;
int screen,x1,r;
Window win,root;
int win_larg, win_haut;
Colormap cmap;

// Couleurs
GC red_gc,green_gc,blue_gc;
XColor red_col,green_col,blue_col;
char red[] = "#FF0000", green[] = "#00FF00", blue[] = "#0000FF";

// Image
XImage *xi;
char *buffer = NULL;
XImage *XIma = NULL;

// Variables polygones
int dim=0;  // nombre de sommet
coord poly[N]; // tableau (liste) de sommet

unsigned long white_pixel, black_pixel;
pile p;

void Remplissageligne(int x,int y,unsigned long cc,unsigned long cr);
void Remplissage(int x,int y,unsigned long cc,unsigned long cr);
void Croix(int x0, int y0);
void Brensenham(int xa, int ya, int xb, int yb, int coul);

// Debut fonction pour la Pile ================================
/* *********************************************************** */

void creer_pile() {
    p.hauteur=-1;
} /* creer_pile */

/* *********************************************************** */

void empiler(coord pt) {
    p.hauteur++;
    p.val[p.hauteur]=pt;
} /* empiler */

/* *********************************************************** */

void depiler() {
    p.hauteur--;
} /* depiler */

/* *********************************************************** */

coord sommet() {
    return p.val[p.hauteur];
} /* sommet */
// Fin fonction pour la Pile ================================

/* *********************************************************** */

int pile_vide() {
    if (p.hauteur<0)
        return 1;
    else
        return 0;
} /* pile_vide */


/* *********************************************************** */

void contact_serveur(void) {
    if ((display = XOpenDisplay(""))==NULL) {
        fprintf(stderr, "can't open display");
        exit(1);
    }
} /* contact_serveur */


/* *********************************************************** */

void Creat_fenetre(void) {
short border_width;

screen = DefaultScreen(display);
root = RootWindow(display,screen);

white_pixel= WhitePixel(display,screen);
black_pixel= BlackPixel(display,screen);

cmap = DefaultColormap(display,screen);
border_width = 3;

win_larg = DisplayWidth(display,screen)/4;
win_haut = DisplayHeight(display,screen)/4;

win = XCreateSimpleWindow(display,root,0,0,win_larg,win_haut,
	border_width,black_pixel,white_pixel);
gc=DefaultGC(display,screen);

XStoreName(display,win,"Remplissage Ligne");
XSetWindowColormap(display, win, cmap) ;

// SetForeground(display, gc, black_pixel);

XMapWindow(display,win);

// On alloue donc le buffer qui va contenir les graphiques manuellement a l'aide d'un malloc

    if (buffer=(char *) malloc(win_larg * win_haut * sizeof(char))) {
      perror("malloc failed \n");
    }

    /* Allocation d'une XImage  partir du buffer, plus rapide pour 
       le dessin et l'affichage qu'un Pixmap */

    xi=XCreateImage(display, DefaultVisual(display, screen) ,8, ZPixmap ,0 ,(char *) buffer,
    	win_larg,win_haut,8,0);
} /* Creat_fenetre */


/* ******************************************************************** */

void gerer_evenement() {
char *str3="Didier STRAUS & Julien GONY";
int i,dist,level,x0,y0;
long int p1,p2,p3;

int res;
int *pBitmap;
int w, h;
int x, y, idx;

level=0;
XSelectInput(display,win,ExposureMask | KeyPressMask | ButtonPressMask);

for(;;) {
        KeySym keysym;
	XEvent ev;
	XNextEvent(display,&ev);

	switch(ev.type){
		case Expose :
			/* On va afficher des dessins ;) */

//    XPutImage(display, win, gc, xi, 0, 0, 0, 0, win_larg, win_haut);
			break;

		case KeyPress :
                        keysym = XLookupKeysym(&ev.xkey, 0);
                        
                        if ((keysym >= XK_Left) && (keysym <= XK_Down)) { // appuyer sur une fleche pour quitter
			 XClearWindow(display,win);
			 XDrawString(display,win,gc,win_larg/5,win_haut/2,str3,strlen(str3));
			 XFlush(display);
			 sleep(3);
			 XDestroyWindow(display,win);
			 XCloseDisplay(display);
			 exit(0);
			}

                        else if (keysym == XK_space) {  // appuyer sur la barre d'espace pouvoir choisir le germe
                            level=2;
			}
			else { // appuyer sur n'importe quelle touche pour arreter la saisie du polygione et le dessiner
                            red_gc = XCreateGC(display, win, 0, 0);
                            XParseColor(display, cmap, red, &red_col);
                            XAllocColor(display, cmap, &red_col);
                            XSetForeground(display, red_gc, red_col.pixel);
                            /* on affiche le polygone qu'on a defini */
                            for(i=0;i<dim-1;i++) {
                                XDrawLine(display,win,red_gc,poly[i].x,poly[i].y,poly[i+1].x,poly[i+1].y);
                                Brensenham(poly[i].x,poly[i].y,poly[i+1].x,poly[i+1].y,couleur);
                            }
                            XDrawLine(display,win,red_gc,poly[dim-1].x,poly[dim-1].y,poly[0].x,poly[0].y);
                            Brensenham(poly[dim-1].x,poly[dim-1].y,poly[0].x,poly[0].y,couleur);
                            level=dim=0;
                        }
                
			break;
		
		case ButtonPress : // le bouton de la souris a ete presse
			/* on recupere les coordonnees de la position de la souris (x,y) */
			x0=ev.xbutton.x;
			y0=ev.xbutton.y;
			
			Croix(x0, y0); // on affiche une petite croix a la position du point
			
			if (level==0) {
                            poly[dim].x = x0;
                            poly[dim].y = y0;
                            dim++;
			}
			else if (level>=1) {
                        // On appelle la fonction remplissage en transmettant les coordonnes du germe.
                            Remplissage(x0, y0, couleur, 88);
                            level=dim=0; // on pourra redefinir un autre polygone a remplir.
			}
			
			break;
		
		default :
			fprintf(stderr,"J'ai recu un evt : %d\n",ev.type);
			break;
	} /* switch */
} /* for */

} /* gerer_evts */


/* *********************************************************** */

void Remplissageligne(int x,int y,unsigned long cc,unsigned long cr) {
  unsigned long cp,cpd,cpg;
  int xd,xg;
  blue_gc = XCreateGC(display, win, 0, 0);
  XParseColor(display, cmap, blue, &blue_col);
  XAllocColor(display, cmap, &blue_col);
  XSetForeground(display, blue_gc, blue_col.pixel);
  
  /* determine les extremitees */
  xd=x;
  cpd=XGetPixel(xi,x,y);
  while((cpd!=cc) && (cpd!=cr)) {
    xd++;
    cpd=XGetPixel(xi,xd,y);
  }
  xd--;
  
  xg=x;
  cpg=XGetPixel(xi,x,y);
  while((cpg!=cc) && (cpd!=cr)) {
    xg--;
    cpg=XGetPixel(xi,xg,y);
  }
  xg++;

  /* On trace la droite */
  XDrawLine(display, win, blue_gc, xg, y, xd, y);
  Brensenham(xg, y, xd, y, cr);
  
  XPutPixel(xi, xg, y, cr); // Pb avec brensham qui ne trace pas les extremites ? :/
  XPutPixel(xi, xd, y, cr);
  
  /* recherche nouveaux germes au dessus */
  x=xd;
  cp=XGetPixel(xi,x,y+1);
  while(x>=xg) {
    while(((cp==cc) || (cp==cr)) && (x>=xg)) { // trouver le 1er pixel a remplir depuis xd
        x--;
        cp=XGetPixel(xi,x,y+1);
    }
    
    if ((x>=xg) && (cp!=cc) && (cp!=cr)) {
        coord c_prov;
        
        c_prov.x = x;
        c_prov.y = y+1;
        
        empiler(c_prov);
     }
    
    // recherche des autres
    while((cp!=cc) && (x>=xg)) {
        x--;
        cp=XGetPixel(xi,x,y+1);
    }
  }

/* recherche nouveaux germes au dessous */

  x=xd;
  cp=XGetPixel(xi,x,y-1);
  while(x>=xg) {
    while(((cp==cc) || (cp==cr)) && (x>=xg)) { // trouver le 1er pixel a remplir depuis xd
        x--;
        cp=XGetPixel(xi,x,y-1);
    }
    
    if ((x>=xg) && (cp!=cc) && (cp!=cr)) {
        coord c_prov;
        
        c_prov.x = x;
        c_prov.y = y-1;
        
        empiler(c_prov);
    }

    // recherche des autres
    while((cp!=cc) && (x>=xg)) {
        x--;
        cp=XGetPixel(xi,x,y-1);
    }
  }

} /* Remplissageligne */


/* *********************************************************** */

void Remplissage(int x,int y,unsigned long cc,unsigned long cr) {
  coord c;
  unsigned long cp;
  
  c.x=x;
  c.y=y;
  creer_pile();
  empiler(c);
  
  while(pile_vide()!=1) {
   c=sommet();
   depiler();
    
   cp=XGetPixel(xi,c.x,c.y);

   if ((cp!=cc) && (cp!=cr)) {
    Remplissageligne(c.x,c.y,cc,cr);
   }
  } // while
} /* Remplissage */

/* *********************************************************** */

// pg principal
int main(void) {
    contact_serveur();
    Creat_fenetre();
    gerer_evenement();

    return 0;
}



/* *********************************************************** */

void Croix(int x0,int y0) {
    XDrawPoint(display,win,gc,x0,y0);
    XDrawPoint(display,win,gc,x0+1,y0);
    XDrawPoint(display,win,gc,x0-1,y0);
    XDrawPoint(display,win,gc,x0,y0-1);
    XDrawPoint(display,win,gc,x0,y0+1);
} /* Croix */


/* ******************************************************************** */

void Brensenham(int xa, int ya, int xb, int yb, int coul) {
 int x,y,dx,dy,incrmX,incrmY,dp,NE,SE;

 dx = xb-xa;
 dy = yb-ya;

 if (dx>0)
  incrmX = 1;
 else {
  incrmX = -1;
  dx *= -1;
 }

 if (dy>0)
  incrmY = 1;
 else {
  incrmY = -1;
  dy *= -1;
 }


 if (dx>=dy) {
  dp=2*dy-dx;
  SE=2*dy;
  NE=2*(dy-dx);

  y=ya;
  for(x=xa;x!=xb;x+=incrmX) {
   /* affichePixel(x,y,coul) */
   XPutPixel(xi, x, y, coul);

   if (dp<=0) /* on choisit le pixel E */
    dp += SE;
   else {
    dp += NE;
    y+=incrmY;
   }
  }
 }
 else if (dx<dy) {
  dp=2*dx-dy;
  SE=2*dx;
  NE=2*(dx-dy);

  x=xa;
  for(y=ya;y!=yb;y+=incrmY) {
   /* affichePixel(x,y,coul) */
   XPutPixel(xi, x, y, coul);
   
   if (dp<=0) /* on choisit le pixel E */
    dp += SE;
   else {
    dp += NE;
    x+=incrmX;
   }
  }
 }
} /* Brensenham */
