#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include<X11/keysym.h>

#define N 30 // nb de sommet maxi pour un polygone
#define couleur 99

/*
Projet Info Graphique (Didier & Julien)

27-03-04  2004 Didier STRAUS www.Software-DS.com
Modifier le 03/04/04

gcc -o Remplissage Remplissage.c -L/usr/X11R6/lib -lX11

gcc Remplissage.c -g -o Remplissage -L/usr/X11R6/lib -lX11

Les croix sont dessinees en noir, les polygones en rouges et ils sont remplis en vert.
Pour quitter le programme appuyer sur une des 4 fleches (haut,bas,gauche,droite)
Pour generer un polygone cliquer avec la souris pour definir ces sommets quand
tous les sommets sont definis appuyer sur une touche (sauf les fleches et la barre d'espace)
Maintenant qu'un polygone est defini vous pouvez soit en definir encore un autre
(autant que vous voulez) . un polygone doit avoir moins de 30 sommet (N).
Pour remplir un polygone , il vous faut determiner un germe, pour cela appuyer sur la barre d'espace
puis avec votre souris cliquer sur la ou voulez votre germe, et hop c'est colorie
maintenant vous pouvez quitter ou alors redessinez encore des polygones et les colorier ;)

*/

typedef struct point {int x; int y;} point;


GC gc;
Display *display;
int screen,N2;
Window win,root;
int win_larg,win_haut;
Colormap cmap;

/* on defini les couleurs */
GC red_gc,green_gc;
XColor red_col,green_col;
char red[] = "#FF0000", green[] = "#00FF00";

/* structure images */
XImage *xi;
char *buffer = NULL;
XImage *XIma = NULL;

/* variables globales */
int dim=0;     // nombre de sommet dans le polygone
point poly[N]; // tableau de sommet(s)

unsigned long white_pixel, black_pixel;

void Croix(int x0, int y0);
void Brensenham(int xa, int ya, int xb, int yb, int coul);
void Remplissage1pt(int x,int y,unsigned long cc,unsigned long cr);


void contact_serveur(){
	if ((display = XOpenDisplay("")) == NULL) {
		fprintf(stderr, "Can't open Display\n");
		exit(1);
	}
} /* contact_serveur */

/* ******************************************************************** */

void Creat_fenetre(void) {
short border_width;

screen = DefaultScreen(display);
root = RootWindow(display,screen);

white_pixel= WhitePixel(display,screen);
black_pixel= BlackPixel(display,screen);

cmap = DefaultColormap(display,screen);

border_width = 3;

win_larg = DisplayWidth(display,screen)/4;
win_haut = DisplayHeight(display,screen)/4;

win = XCreateSimpleWindow(display,root,0,0,win_larg,win_haut,
	border_width,black_pixel,white_pixel);
gc=DefaultGC(display,screen);

XStoreName(display,win,"Remplissage Version avec germe");

XSetWindowColormap(display, win, cmap) ;

// SetForeground(display, gc, black_pixel);

XMapWindow(display,win);

// On alloue donc le buffer qui va contenir les graphiques manuellement a l'aide d'un malloc

    if (buffer=(char *) malloc(win_larg * win_haut * sizeof(char))) {
      perror("malloc failed \n");
    }


    /* Allocation d'une XImage  partir du buffer, plus rapide pour 
       le dessin et l'affichage qu'un Pixmap */

    xi=XCreateImage(display, DefaultVisual(display, screen) ,8, ZPixmap ,0 ,(char *) buffer,
    	win_larg,win_haut,8,0);

}

/* ******************************************************************** */

void gerer_evenement(){
char *str3="Didier STRAUS & Julien GONY";
int i,dist,level,x0,y0;
long int p1,p2,p3;

int res;
int *pBitmap;
int w, h;
int x, y, idx;

level=0;
XSelectInput(display,win,ExposureMask | KeyPressMask | ButtonPressMask);

for(;;) {
	KeySym keysym;
	XEvent ev;
	XNextEvent(display,&ev);

	switch(ev.type){
		case Expose :
			/* On va afficher des dessins ;) */

//    XPutImage(display, win, gc, xi, 0, 0, 0, 0, win_larg, win_haut);

			break;

		case KeyPress :
			keysym = XLookupKeysym(&ev.xkey, 0);
  
    		if ((keysym >= XK_Left) && (keysym <= XK_Down)) { // appuyer sur une fleche pour quitter
				XClearWindow(display,win);
				XDrawString(display,win,gc,win_larg/3,win_haut/3,str3,strlen(str3));
				XFlush(display);
				sleep(3);
				XDestroyWindow(display,win);
				XCloseDisplay(display);
				exit(0);
			}
			else if (keysym == XK_space) {  // appuyer sur la barre d'espace pouvoir choisir le germe
				level=2;
			}
			else { // appuyer sur n'importe quelle touche pour arreter la saisie du polygione et le dessiner
				level=1;
				if (level==1) {
					/* on affiche le polygone qu'on a defini */
				

					for(i=0;i<dim-1;i++) {
			 		 XDrawLine(display,win,gc,poly[i].x,poly[i].y,poly[i+1].x,poly[i+1].y);
			 		 Brensenham(poly[i].x,poly[i].y,poly[i+1].x,poly[i+1].y,couleur);
                                        }
			 	// on relis le dernier sommet au premier
			 	 XDrawLine(display,win,gc,poly[dim-1].x,poly[dim-1].y,poly[0].x,poly[0].y);
				 Brensenham(poly[dim-1].x,poly[dim-1].y,poly[0].x,poly[0].y,couleur);
                                }
			 level=dim=0;
                        }
                        break;
		
		
		case ButtonPress : // le bouton de la souris a ete presse
			/* on recupere les coordonnees de la position de la souris (x,y) */
			x0=ev.xbutton.x;
			y0=ev.xbutton.y;
						
			if (level==0) {
				Croix(x0, y0); // on affiche une petite croix a la position du point
				poly[dim].x = x0;
				poly[dim].y = y0;
				dim++;
			}
			else if (level==2) {
				// memoriser les valeurs du germes.
				green_gc = XCreateGC(display, win, 0, 0);
 				XParseColor(display, cmap, green, &green_col);
				XAllocColor(display, cmap, &green_col);
				XSetForeground(display, green_gc, green_col.pixel);
				
				Remplissage1pt(x0, y0, 88, couleur);
				level=0; // comme ca on peut definir d'autres polygones et les remplir ;)
			}
			
			break;
		
		default :
			fprintf(stderr,"J'ai recu un evt : %d\n",ev.type);
			break;
	} /* switch */
} /* for */

} /* gerer_evts */


/* ******************************************************************** */

int main () {
	int i;
	
	for(i=0;i<N;i++) {
		poly[i].x=0;
		poly[i].y=0;
	}

	contact_serveur();
	Creat_fenetre();
	gerer_evenement();

	return 0;
}


/* *********************************************************** */

void Croix(int x0,int y0) {
	XDrawPoint(display,win,gc,x0,y0);
	XDrawPoint(display,win,gc,x0+1,y0);
	XDrawPoint(display,win,gc,x0-1,y0);
	XDrawPoint(display,win,gc,x0,y0-1);
	XDrawPoint(display,win,gc,x0,y0+1);
} /* Croix */

/* ******************************************************************** */

void Remplissage1pt(int x,int y,unsigned long cc,unsigned long cr) {
  unsigned long cp;
  
  cp=XGetPixel(xi,x,y);
  
  if ((cp!=cc) && (cp!=cr)) {
    XDrawPoint(display, win, green_gc,x,y);
	XPutPixel(xi, x, y, cr);	
    Remplissage1pt(x-1,y,cc,cr);
    Remplissage1pt(x+1,y,cc,cr);
    Remplissage1pt(x,y-1,cc,cr);
    Remplissage1pt(x,y+1,cc,cr);
  }
}

/* ******************************************************************** */

void Brensenham(int xa, int ya, int xb, int yb, int coul) {
 int x,y,dx,dy,incrmX,incrmY,dp,NE,SE;
 red_gc = XCreateGC(display, win, 0, 0);
 XParseColor(display, cmap, red, &red_col);
 XAllocColor(display, cmap, &red_col);
 XSetForeground(display, red_gc, red_col.pixel);

 dx = xb-xa;
 dy = yb-ya;

 if (dx>0)
  incrmX = 1;
 else {
  incrmX = -1;
  dx *= -1;
 }

 if (dy>0)
  incrmY = 1;
 else {
  incrmY = -1;
  dy *= -1;
 }


 if (dx>=dy) {
  dp=2*dy-dx;
  SE=2*dy;
  NE=2*(dy-dx);

  y=ya;
  for(x=xa;x!=xb;x+=incrmX) {
   /* affichePixel(x,y,coul) */
   XDrawPoint(display,win,red_gc,x, y);
   XPutPixel(xi, x, y, coul);

   if (dp<=0) /* on choisit le pixel E */
    dp += SE;
   else {
    dp += NE;
    y+=incrmY;
   }
  }
 }
 else if (dx<dy) {
  dp=2*dx-dy;
  SE=2*dx;
  NE=2*(dx-dy);

  x=xa;
  for(y=ya;y!=yb;y+=incrmY) {
   /* affichePixel(x,y,coul) */
   XDrawPoint(display,win,red_gc,x, y);
   XPutPixel(xi, x, y, coul);

   if (dp<=0) /* on choisit le pixel E */
    dp += SE;
   else {
    dp += NE;
    x+=incrmX;
   }
  }
 }
} /* Brensenham */

